#include "More_atom_types.h"

#define DEFAULT_RESIDUES "\
U 20\n\
  N1    N3H0u\n\
  C2    C3H0s\n\
  O2    O1H0u\n\
  N3    N3H1s\n\
  C4    C3H0s\n\
  O4    O1H0u\n\
  C5    C3H1b\n\
  C6    C3H1t\n\
  C1*   C4H1b\n\
  C2*   C4H1s\n\
  C3*   C4H1s\n\
  C4*   C4H1b\n\
  O2*   O2H1u\n\
  O3*   O2H0b\n\
  O4*   O2H0s\n\
  C5*   C4H2s\n\
  O5*   O2H0b\n\
  P     P4H0u\n\
  O1P   O1H0u\n\
  O2P   O1H0u\n\
\n\
A 22\n\
  N1    N2H0s\n\
  C2    C3H1s\n\
  N3    N2H0b\n\
  C4    C3H0s\n\
  C5    C3H0s\n\
  C6    C3H0s\n\
  N6    N3H2u\n\
  N7    N2H0b\n\
  C8    C3H1s\n\
  N9    N3H0u\n\
  C1*   C4H1b\n\
  C2*   C4H1s\n\
  C3*   C4H1s\n\
  C4*   C4H1b\n\
  O2*   O2H1u\n\
  O3*   O2H0b\n\
  O4*   O2H0s\n\
  C5*   C4H2s\n\
  O5*   O2H0b\n\
  P     P4H0u\n\
  O1P   O1H0u\n\
  O2P   O1H0u\n\
\n\
G 23\n\
  N1    N3H1s\n\
  C2    C3H0s\n\
  N2    N3H2u\n\
  N3    N2H0b\n\
  C4    C3H0s\n\
  C5    C3H0s\n\
  C6    C3H0s\n\
  O6    O1H0u\n\
  N7    N2H0b\n\
  C8    C3H1s\n\
  N9    N3H0u\n\
  C1*   C4H1b\n\
  C2*   C4H1s\n\
  C3*   C4H1s\n\
  C4*   C4H1b\n\
  O2*   O2H1u\n\
  O3*   O2H0b\n\
  O4*   O2H0s\n\
  C5*   C4H2s\n\
  O5*   O2H0b\n\
  P     P4H0u\n\
  O1P   O1H0u\n\
  O2P   O1H0u\n\
\n\
C 20\n\
  N1    N3H0u\n\
  C2    C3H0s\n\
  O2    O1H0u\n\
  N3    N2H0s\n\
  C4    C3H0s\n\
  N4    N3H2u\n\
  C5    C3H1b\n\
  C6    C3H1t\n\
  C1*   C4H1b\n\
  C2*   C4H1s\n\
  C3*   C4H1s\n\
  C4*   C4H1b\n\
  O2*   O2H1u\n\
  O3*   O2H0b\n\
  O4*   O2H0s\n\
  C5*   C4H2s\n\
  O5*   O2H0b\n\
  P     P4H0u\n\
  O1P   O1H0u\n\
  O2P   O1H0u\n\
\n\
GLY 4\n\
  O     O1H0u\n\
  C     C3H0b\n\
  CA    C4H2s\n\
  N     N3H1s\n\
\n\
ALA 5\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1b\n\
  N     N3H1s\n\
  CB    C4H3u\n\
\n\
VAL 7\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H1b\n\
  CG1   C4H3u\n\
  CG2   C4H3u\n\
\n\
LEU 8\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C4H1b\n\
  CD1   C4H3u\n\
  CD2   C4H3u\n\
\n\
ILE 8\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H1b\n\
  CG1   C4H2b\n\
  CG2   C4H3u\n\
  CD1   C4H3u\n\
\n\
\n\
PRO 7\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1b\n\
  N     N3H0u\n\
  CB    C4H2b\n\
  CG    C4H2b\n\
  CD    C4H2s\n\
\n\
MET 8\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C4H2b\n\
  SD    S2H0u\n\
  CE    C4H3u\n\
\n\
PHE 11\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C3H0b\n\
  CD1   C3H1s\n\
  CD2   C3H1b\n\
  CE1   C3H1b\n\
  CE2   C3H1b\n\
  CZ    C3H1b\n\
\n\
TYR 12\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C3H0b\n\
  CD1   C3H1s\n\
  CD2   C3H1s\n\
  CE1   C3H1s\n\
  CE2   C3H1s\n\
  CZ    C3H0b\n\
  OH    O2H1u\n\
\n\
\n\
TRP 15\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C3H0b\n\
  CD1   C3H1s\n\
  NE1   N3H1b\n\
  CD2   C3H0b\n\
  CE2   C3H0b\n\
  CE3   C3H1b\n\
  CZ3   C3H1b\n\
  CZ2   C3H1b\n\
  CH2   C3H1b\n\
  CEH2 =CH2\n\
\n\
SER 7\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  OG    O2H1u\n\
  OG1  =OG\n\
\n\
THR 8\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H1b\n\
  OG1   O2H1u\n\
  CG2   C4H3u\n\
  CG  =CG2\n\
\n\
ASN 8\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C3H0b\n\
  OD1   O1H0u\n\
  ND2   N3H2u\n\
\n\
\n\
GLN 9\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C4H2s\n\
  CD    C3H0b\n\
  OE1   O1H0u\n\
  NE2   N3H2u\n\
\n\
CYS 6\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2b\n\
  SG    S2H1u\n\
\n\
CSS 6\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2b\n\
  SG    S2H0u\n\
\n\
HIS 10\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C3H0b\n\
  ND1   N3H1b\n\
  CD2   C3H1s\n\
  CE1   C3H1s\n\
  NE2   N3H1b\n\
\n\
\n\
GLU 9\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C4H2s\n\
  CD    C3H0b\n\
  OE1   O1H0u\n\
  OE2   O1H0u\n\
\n\
\n\
ASP 8\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C3H0b\n\
  OD1   O1H0u\n\
  OD2   O1H0u\n\
\n\
\n\
ARG 11\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C4H2s\n\
  CD    C4H2s\n\
  NE    N3H1b\n\
  CZ    C3H0b\n\
  NH1   N3H2u\n\
  NH2   N3H2u\n\
\n\
LYS 9\n\
  O     O1H0u\n\
  C     C3H0s\n\
  CA    C4H1s\n\
  N     N3H1s\n\
  CB    C4H2s\n\
  CG    C4H2s\n\
  CD    C4H2s\n\
  CE    C4H2b\n\
  NZ    N4H3u\n\
\n\
ZN 1\n\
   ZN Z2ION\n\
\n\
HEM 39\n\
  FE   FE\n\
  CMA  C4H3u\n\
  CMB  C4H3u\n\
  CMC  C4H3u\n\
  CMD  C4H3u\n\
  CAA  C4H2b\n\
  CBA  C4H2b\n\
  CAD  C4H2b\n\
  CBD  C4H2b\n\
  CAB  C3H1s\n\
  CH   C3H1s\n\
  CAC  C3H1s\n\
  CBC  C3H2u\n\
  CBB  C3H2u\n\
  NA   N3H0u\n\
  NB   N3H0u\n\
  NC   N3H0u\n\
  ND   N3H0u\n\
  O1A  O1H0u\n\
  O1B  O1H0u\n\
  O1C  O1H0u\n\
  O1D  O1H0u\n\
  C1A  C3H0b\n\
  C2A  C3H0b\n\
  C3A  C3H0b\n\
  C4A  C3H0b\n\
  CGA  C3H0b\n\
  C1B  C3H0b\n\
  C2B  C3H0b\n\
  C3B  C3H0b\n\
  C4B  C3H0b\n\
  C1C  C3H0b\n\
  C2C  C3H0b\n\
  C3C  C3H0b\n\
  C4C  C3H0b\n\
  C1D  C3H0b\n\
  C2D  C3H0b\n\
  C3D  C3H0b\n\
  C4D  C3H0b\n\
\n\
\n\
ACE 10\n\
  CH3 C4H3u\n\
\n\
ASH 1\n\
\n\
WAT 2\n\
  O O2H2u\n\
  OW =O\n\
\n\
HOH 2\n\
  O O2H2u\n\
  OW =O\n\
\n\
DUM 12\n\
  OT  O1H0u\n\
  OXT O1H0u\n\
  OT1 O1H0u\n\
  OT2 O1H0u\n\
  OE  O1H0u\n\
  NT  N4H3u\n\
  Z   Z2ION\n\
  DUM DEFAULT\n\
  NDUM  N4H3u\n\
  ODUM  O2H1u\n\
  CDUM  C4H2b\n\
  MG    MGION\n\
"

#define NUCPROT_RADII "\
C3H0s   1.61    0.72\n\
C3H0b   1.61    0.72\n\
C3H1t   1.76    0.68\n\
C3H1s   1.76    0.68\n\
C3H1b   1.76    0.68\n\
C3H2u   1.76    0.77\n\
C4H1s   1.88    0.78\n\
C4H1b   1.88    0.78\n\
C4H2s   1.88    0.76\n\
C4H2b   1.88    0.76\n\
C4H3u   1.88    0.74\n\
N2H0s   1.64    0.64\n\
N2H0b   1.64    0.64\n\
N3H0u   1.64    0.69\n\
N3H1s   1.64    0.67\n\
N3H1b   1.64    0.67\n\
N3H2u   1.64    0.61\n\
N4H3u   1.64    0.73\n\
O1H0u   1.42    0.52\n\
O2H0s   1.50    0.65\n\
O2H0b   1.62    0.65\n\
O2H1u   1.46    0.65\n\
O2H2u   1.46    0.66\n\
S2H0u   1.77    1.04\n\
S2H1u   1.77    1.04\n\
P4H0u   1.82    0.97\n\
O1N3HH  1.60    0.68\n\
Z2ION   0.74    0.74\n\
FE      1.70    0.70\n\
MGION   1.59    0.70\n\
DEFAULT 1.70    0.77\n\
"

void WriteAtomTypes()
{
  int ii ;
  
  /* ii used to run from 0. See bug fix in atom_types.c */
  for (ii =1 ; ii < MAX_ATOM_TYPE ; ii++) {
    char *k =  atom_type_names[ii].name ;
    if (k == NULL ) break ;
    printf("%3d %8s %7.4f %7.4f %7.4f\n",ii,k,atom_vdw[ii],atom_covalent[ii],
	   atom_charge[ii]);
  }
}

void UpdateAtomTypes(FILE * ff)
{
  char string[200] ; 
  
  while (fgets(string,200,ff) != NULL) {
    char name [200] ; 
    double charge,vdw,covalent;
    int ii ;
    
    
    ii = sscanf(string, LF_STRING_02, name,&vdw,&covalent,&charge) ;
    
    if (ii > 0) {
      if (ii < 3)
	serious_error(1, "Something wrong in atom type", string) ;
      
      ii = find_type_definition(name) ;
      atom_charge[ii] = charge;
      atom_covalent[ii] = covalent;
      atom_vdw[ii] = vdw;
    }
  }
  read_residue_definitions (stream_from_string(DEFAULT_RESIDUES)) ;
}

